#include <iostream>

#include <stack>


using namespace std;



//http://kldp.org/node/153572
//http://thrillfighter.tistory.com/199
//http://www.tipssoft.com/bulletin/board.php?bo_table=FAQ&wr_id=1463
//http://pacs.tistory.com/entry/C-Լ-ø-Ŭ-ø-Function-template-Class-template

stack<int> st;



//
template <typename E>
class Node
{
public:
    Node(){};
    ~Node(){};

    E elem;
    Node<E>* next;
};





#if 1

template <typename E>
class Stack
{
public:
    Stack();
    ~Stack();
    void push(const E& e);
    void pop();
    const E& top() const;
    const bool empty() const;
    const int size() const;
    
private:
    Node<E>* head;
    Node<E>* tail;
    Node<E>* current;
    int capacity;
};



template <typename E>
Stack<E>::Stack()
{
    head = nullptr;
    tail = nullptr;
    current = nullptr;
    capacity = 0;
}

template <typename E>
Stack<E>::~Stack()
{
    if (head != nullptr)
    {
        current = head->next;
        delete head;
        head = current;
    }
}

template <typename E>
void Stack<E>::push(const E & e)
{
    current = new Node<E>();
    current->elem = e;
    current->next = head;
    head = current;
    capacity++;
}

template <typename E>
void Stack<E>::pop()
{
    if (head != nullptr) 
    {
        current = head->next;
        delete head;
        head = current;
        capacity--;
    }
}

template <typename E>
const E & Stack<E>::top() const
{
    return head->elem;
}

template <typename E>
const bool Stack<E>::empty() const
{
    if (capacity != 0) return false;
    else return true;
}

template <typename E>
const int Stack<E>::size() const
{
    return capacity;
}

#endif





int main(int argc, char** argv)
{
    Stack<int> a;
    a.pop();
    a.push(7);
    cout << ": " << a.size() << endl;
    a.push(13);
    cout << a.top() << endl;
    a.pop();
    a.push(9);
    cout << a.top() << endl;
    cout << a.top() << endl; a.pop();

    int i=0;
    for(i=0; i<100000; i++)
        a.push(i);
        
    for(i=0; i<100000; i++)
    {
//        cout << a.top() << endl; a.pop();
    }


    Stack<const char *> B;
    B.push("bob");
    B.push("Alice");
    cout << B.top() << endl; B.pop();
    B.push("Eve");

    for(i=0; i<100000; i++)
        B.push("testtesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttesttest");

    for(i=0; i<100000; i++)
    {
//        cout << B.top() << endl; B.pop();
    }
    return 0;
}









